// Calculates checksum for GPS NMEA sentences in a file

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[]) {
   int i;
   FILE *fp = NULL;
   char c, check=0;   

   if (argc != 2) {
      printf("Usage: %s in-file\n", argv[0]);
      return 0;
   }

   if ((fp = fopen(argv[1], "r"))) {
      while (fread(&c, 1, 1, fp)) {
         if (c == '*') {
            // end reached
            break;
         }
         if (c != '$') {
            // xor onto check sum
            check ^= c;
         }
      }
      
      printf("Checksum: %02X\n", check);

      fclose(fp);
   }
   else {
      printf("Could not open: %s\n", argv[1]);
   }

   return 0;
}
